SystemOrganization addCategory: #'OCMSTest-Kernel'!

Object subclass: #ObjectFactoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!ObjectFactoryTest class methodsFor: 'author creation' stamp: 'has 6/24/2013 10:27'!
createAuthorCollection1
	| authorList |
	authorList:=OrderedCollection new.
	authorList add: 'J.K.Test'.
	^authorList.! !

!ObjectFactoryTest class methodsFor: 'author creation' stamp: 'has 6/24/2013 10:28'!
createAuthorCollection2
	| authorList |
	authorList:=OrderedCollection new.
	authorList add: 'Author 1'.
	authorList add: 'Author 2'.
	^authorList.! !

!ObjectFactoryTest class methodsFor: 'comment creation' stamp: 'has 6/24/2013 09:36'!
createComment1
	| comment |
	comment := Comment new.
	comment user: self createUser1Enabled.
	comment text: 'Comment to test'.
	comment dateAndTime: DateAndTime now.
	comment createId.
	^comment.
	! !

!ObjectFactoryTest class methodsFor: 'comment creation' stamp: 'has 6/24/2013 09:36'!
createComment2
	| comment |
	comment := Comment new.
	comment user: self createUser1Enabled.
	comment text: 'New comment of courseware'.
	comment dateAndTime: DateAndTime now.
	comment createId.
	^comment.
	! !

!ObjectFactoryTest class methodsFor: 'course creation' stamp: 'has 6/28/2013 15:47'!
createCourse1WithinGroup
	| aCourse aGroup |
	aGroup := Group new.
	aGroup description: 'POO 2013 Ps'.
	aGroup owner: ObjectFactoryTest createUserAdmin1.
	aGroup creationDateTime: DateAndTime now.
	aGroup isEnabled: true.
	  
	aCourse := Course new.
	aCourse description: 'Programao Orientada a Objetos'.
	aCourse category: 'Cincias da Computao'.
	aCourse includeGroup: aGroup. "This already updates the course within the group."
	
	^aCourse. ! !

!ObjectFactoryTest class methodsFor: 'course creation' stamp: 'has 6/28/2013 15:47'!
createCourse2WithinGroup
	| aCourse aGroup |
	aGroup := Group new.
	aGroup description: 'POO 2013 graduao'.
	aGroup owner: ObjectFactoryTest createUserAdmin1.
	aGroup creationDateTime: DateAndTime now.
	aGroup isEnabled: true.
	  
	aCourse := Course new.
	aCourse description: 'Programao Orientada a Objetos'.
	aCourse category: 'Cincias da Computao'.
	aCourse includeGroup: aGroup. "This already updates the course within the group."
	
	^aCourse.  ! !

!ObjectFactoryTest class methodsFor: 'course creation' stamp: 'has 6/28/2013 17:31'!
createCourseToGetAllModerators
	| aCourse aGroup |
	aGroup := Group new.
	aGroup description: 'Group for course with two moderators'.
	aGroup owner: ObjectFactoryTest createUserAdmin1.
	aGroup includeOrUpdateUser: ObjectFactoryTest createUser1Enabled withRole: UserType moderator.
	aGroup includeOrUpdateUser: ObjectFactoryTest createUser2Enabled withRole: UserType moderator.
	aGroup includeOrUpdateUser: ObjectFactoryTest createUser1Disabled withRole: UserType student.
	aGroup creationDateTime: DateAndTime now.
	aGroup isEnabled: true.
	  
	aCourse := Course new.
	aCourse description: 'Course with two moderators'.
	aCourse category: 'Science'.
	aCourse includeGroup: aGroup. "This already updates the course within the group."
	
	^aCourse. ! !

!ObjectFactoryTest class methodsFor: 'courseware creation' stamp: 'has 6/24/2013 10:44'!
createCoursewareNew1
	| courseware |
	courseware:= Courseware new.
	courseware title: 'CoursewareTest'.
	courseware description: 'An instance of a courseware'.
	courseware summary: 'A summary of a courseware'.
	courseware owner: self createUser1Enabled.
	courseware coursewareType: CoursewareType slide.
	courseware author: self createAuthorCollection1.
	courseware creationDateTime: DateAndTime now.
	courseware file: 'Slide.pdf'.
	courseware size: 2.3.
	courseware tag: self createTagCollection1.
	courseware isEnabled: true.
	^courseware.
	! !

!ObjectFactoryTest class methodsFor: 'courseware creation' stamp: 'has 6/24/2013 10:44'!
createCoursewareNew2
	| courseware |
	courseware:= Courseware new.
	courseware title: 'CoursewareTest2'.
	courseware description: 'Another instance of a courseware'.
	courseware summary: 'Summary of a courseware 2'.
	courseware owner: self createUser1Enabled.
	courseware coursewareType: CoursewareType audio.
	courseware author: self createAuthorCollection2.
	courseware creationDateTime: DateAndTime now.
	courseware file: 'Audio.mp3'.
	courseware size: 10.5.
	courseware tag: self createTagCollection2.
	courseware isEnabled: true.
	^courseware.! !

!ObjectFactoryTest class methodsFor: 'courseware creation' stamp: 'has 6/24/2013 10:45'!
createCoursewareNewBlocked1
	| courseware |
	courseware:= Courseware new.
	courseware title: 'CoursewareTest'.
	courseware description: 'An instance of a courseware'.
	courseware summary: 'A summary of a courseware'.
	courseware owner: self createUser1Enabled.
	courseware coursewareType: CoursewareType slide.
	courseware author: self createAuthorCollection1.
	courseware creationDateTime: DateAndTime now.
	courseware file: 'Slide.pdf'.
	courseware size: 2.3.
	courseware tag: self createTagCollection1.
	^courseware.
	! !

!ObjectFactoryTest class methodsFor: 'courseware creation' stamp: 'has 6/24/2013 10:45'!
createCoursewareUpdateWithComment1
	| courseware |
	courseware:= Courseware new.
	courseware title: 'CoursewareTestUpdate'.
	courseware description: 'An instance of a courseware'.
	courseware summary: 'A summary of a courseware'.
	courseware owner: self createUser1Enabled.
	courseware coursewareType: CoursewareType slide.
	courseware author: self createAuthorCollection1.
	courseware modificationDateTime: DateAndTime now.
	courseware file: 'Slide.pdf'.
	courseware size: 2.3.
	courseware downloadCounter: 2.
	courseware comment: self createComment1.
	courseware tag: self createTagCollection1.
	courseware isEnabled: true.
	^courseware.
	! !

!ObjectFactoryTest class methodsFor: 'group creation' stamp: 'has 6/28/2013 15:51'!
createGroup1WithinCourse
	| aCourse aGroup |
	aGroup := Group new.
	aGroup description: 'POO 2013 Ps'.
	aGroup owner: ObjectFactoryTest createUserAdmin1.
	aGroup creationDateTime: DateAndTime now.
	aGroup isEnabled: true.
	  
	aCourse := Course new.
	aCourse description: 'Programao Orientada a Objetos'.
	aCourse category: 'Cincias da Computao'.
	aCourse includeGroup: aGroup. "This already updates the course within the group."
	
	^aGroup. ! !

!ObjectFactoryTest class methodsFor: 'group creation' stamp: 'has 6/28/2013 15:52'!
createGroup2WithinCourse
	| aCourse aGroup |
	aGroup := Group new.
	aGroup description: 'POO 2013 graduao'.
	aGroup owner: ObjectFactoryTest createUserAdmin1.
	aGroup creationDateTime: DateAndTime now.
	aGroup isEnabled: true.
	  
	aCourse := Course new.
	aCourse description: 'Programao Orientada a Objetos'.
	aCourse category: 'Cincias da Computao'.
	aCourse includeGroup: aGroup. "This already updates the course within the group."
	
	^aGroup.  ! !

!ObjectFactoryTest class methodsFor: 'notification creation' stamp: 'has 6/24/2013 13:01'!
createNormalNotification
	| normalNotification |
	normalNotification := OCMSNotification new title: 'Normal Notification';
		body: 'This is a normal notification.';
		sender: ObjectFactoryTest createUser2Enabled.
	normalNotification addReceiver: ObjectFactoryTest createUser1Enabled.
	^normalNotification.! !

!ObjectFactoryTest class methodsFor: 'notification creation' stamp: 'has 6/24/2013 12:54'!
createSystemNotification
	| systemNotification |
	systemNotification := OCMSNotification new title: 'System Notification';
		body: 'This is a system notification';
		isSystemNotification: true.
	systemNotification addReceiver: ObjectFactoryTest createUser1Enabled; 
		addReceiver: ObjectFactoryTest createUser2Enabled.
	^systemNotification.! !

!ObjectFactoryTest class methodsFor: 'tag creation' stamp: 'has 6/27/2013 09:49'!
createTagCollection1
	| tag tagList |
	tagList := OrderedCollection new.
	tag := Tag new.
	tag label: 'Tag test 1'.
	tagList add: tag.
	^tagList! !

!ObjectFactoryTest class methodsFor: 'tag creation' stamp: 'has 6/27/2013 09:49'!
createTagCollection2
	| tag tagList tag2 |
	tagList := OrderedCollection new.
	tag := Tag new.
	tag label: 'Tag test 1'.
	tag2 := Tag new.
	tag2 label: 'Tag test 2'.
	tagList add: tag2.
	^tagList! !

!ObjectFactoryTest class methodsFor: 'user creation' stamp: 'oda 6/30/2013 23:35'!
createUser1Disabled
	| user |
	user:=User new.
	user login: 'disable'.
	user username: 'User Disable'.
	user email: 'disable@test.com'.
	user password: '123456' hash.
	^user.! !

!ObjectFactoryTest class methodsFor: 'user creation' stamp: 'oda 6/30/2013 23:35'!
createUser1Enabled
	| user |
	user:=User new.
	user login: 'user1'.
	user username: 'User Number 1'.
	user email: 'user1@test.com'.
	user password: '123456' hash.
	user isEnabled: true.
	^user.! !

!ObjectFactoryTest class methodsFor: 'user creation' stamp: 'oda 6/30/2013 23:35'!
createUser2Enabled
	| user |
	user:=User new.
	user login: 'enabled2'.
	user username: 'User Number 2'.
	user email: 'enabled2@test.com'.
	user password: '123456' hash.
	user isEnabled: true.
	^user.! !

!ObjectFactoryTest class methodsFor: 'user creation' stamp: 'oda 6/30/2013 23:35'!
createUserAdmin1
	| user |
	user:=User new.
	user login: 'admin1'.
	user username: 'Admin Number 1'.
	user email: 'admin1@test.com'.
	user password: '123456' hash.
	user isEnabled: true.
	user isAdmin: true.
	^user.! !

!ObjectFactoryTest class methodsFor: 'user creation' stamp: 'oda 6/30/2013 23:35'!
createUserAdmin2
	| user |
	user:=User new.
	user login: 'adminuser2'.
	user username: 'Admin Number 2'.
	user email: 'adminuser2@test.com'.
	user password: '123456' hash.
	user isEnabled: true.
	user isAdmin: true.
	^user.! !

!ObjectFactoryTest class methodsFor: 'user creation' stamp: 'has 6/24/2013 10:53'!
createUserCollection1
	| userCollection |
	userCollection := OrderedCollection new.
	userCollection add: self createUser1Enabled.
	userCollection add: self createUser2Enabled.
	^userCollection.! !

TestCase subclass: #CommentTest
	instanceVariableNames: 'comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!CommentTest commentStamp: 'HAS 4/30/2013 20:13' prior: 0!
I test the class Comment!

!CommentTest methodsFor: 'initialize-release' stamp: 'HAS 4/30/2013 20:14'!
setUp

	comment := Comment new.! !

!CommentTest methodsFor: 'testing' stamp: 'has 6/27/2013 19:10'!
testAsCreateId
	
	| userT dateTime hashT |
	userT := User new.
	userT login: 'userlogin'.
	userT username: 'Test User'.
	userT email: 'user@test.com'.
	comment user: userT.
	comment text: 'Notification content'.
	dateTime := DateAndTime now.
	comment dateAndTime: dateTime.
	hashT := [comment user login, '|',  comment dateAndTime, '|', comment text] value hash.
	
	comment createId.
	self assert: comment id = hashT.! !

!CommentTest methodsFor: 'testing' stamp: 'oda 5/13/2013 03:21'!
testAsDateAndTime
	| aDateAndTime |
	aDateAndTime := DateAndTime now.
	comment dateAndTime: aDateAndTime.
	
	self assert: comment dateAndTime = aDateAndTime.! !

!CommentTest methodsFor: 'testing' stamp: 'has 6/27/2013 19:10'!
testAsHash
	
	| userT dateTime hashT |
	userT := User new.
	userT login: 'userlogin'.
	userT username: 'Test User'.
	userT email: 'user@test.com'.
	comment user: userT.
	comment text: 'Notification content'.
	dateTime := DateAndTime now.
	comment dateAndTime: dateTime.
	hashT := [comment user login, '|',  comment dateAndTime, '|', comment text] value hash.
	
	self assert: comment hash = hashT.! !

!CommentTest methodsFor: 'testing' stamp: 'HAS 4/30/2013 20:18'!
testAsText

	comment text: 'This is a comment regarding the courseware'.
	
	self assert: comment text = 'This is a comment regarding the courseware'.! !

!CommentTest methodsFor: 'testing' stamp: 'has 6/27/2013 19:10'!
testAsUser
	
	| userT |
	userT := User new.
	userT login: 'userlogin'.
	userT username: 'Test User'.
	userT email: 'user@test.com'.
	comment user: userT.
	
	self assert: comment user = userT.! !

TestCase subclass: #CourseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!CourseTest methodsFor: 'testing' stamp: 'has 6/28/2013 17:35'!
testAsGetAllGroupModerators
	
	| courseTest listModerator |
	courseTest := ObjectFactoryTest createCourseToGetAllModerators.
	listModerator:= courseTest getAllCourseModerators.
	self assert:(listModerator size = 2).! !

TestCase subclass: #CoursewareManagerTest
	instanceVariableNames: 'coursewareManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!CoursewareManagerTest commentStamp: 'HAS 4/30/2013 20:13' prior: 0!
I test the class CoursewareManagement!

!CoursewareManagerTest methodsFor: 'initialize-release' stamp: 'HAS 4/29/2013 20:02'!
setUp
	coursewareManager := CoursewareManager new.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'has 6/27/2013 19:11'!
testAsBlockCoursewareNormal

	| coursewareTemp userTemp |

	coursewareTemp := Courseware new.
	userTemp := User new.
	userTemp username: 'User'.
	userTemp login: 'login'.
	coursewareTemp title: 'CoursewareTest'.
	coursewareTemp owner: userTemp.
	Coursewares add: coursewareTemp.
	coursewareManager courseware: (coursewareManager blockCourseware: coursewareTemp user: userTemp).

	self assert: coursewareManager courseware isEnabled = false.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'has 6/27/2013 19:11'!
testAsCalculatedRatingScore

	| cm coursewareTemp rating user1 user2 |
	coursewareTemp := ObjectFactoryTest createCoursewareNew1.
	cm := CoursewareManager new.
	cm includeCourseware: coursewareTemp.
	user1 := User new.
	user1 username: 'User 1'.
	user1 login: 'user1'.
	user2 := User new.
	user2 username: 'User 2'.
	user2 login: 'user2'.
	cm includeOrUpdateCoursewareScore: coursewareTemp ofUser: user1 withScore: 5.0.
	cm includeOrUpdateCoursewareScore: coursewareTemp ofUser: user2 withScore: 4.0.

	rating := cm calculateRatingScore: coursewareTemp.

	self assert: rating = 4.5.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'has 6/27/2013 19:12'!
testAsHasWritePermissionWithCourseNormal

	| cm cw user1 user2 |
	user1 := User new.
	user1 username: 'User 1'.
	user1 login: 'user1'.
	user2 := User new.
	user2 username: 'User 2'.
	user2 login: 'user2'.

	cw := Courseware new.
	cw owner: user1.

	cm := CoursewareManager new.
	cm includeUserWritePermission: cw user: user2.
	
	self assert: ((cm hasWritePermission: user2 withCourseware: cw) = true).! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'has 6/24/2013 16:14'!
testAsIncludeCommentNormal

	| commentTemp coursewareTemp |

	commentTemp := Comment new.
	commentTemp user: ObjectFactoryTest createUser1Enabled.
	commentTemp dateAndTime: DateAndTime now.
	commentTemp text: 'This is a comment about the courseware'.
	
	coursewareTemp := ObjectFactoryTest createCoursewareNew1.
	coursewareManager includeCourseware: coursewareTemp.
	coursewareManager includeComment: coursewareTemp comment: commentTemp.
	coursewareManager courseware: (Coursewares searchById:(Coursewares incrementId - 1)).
	
	self assert: coursewareManager courseware comment size = 1.
	self assert: (coursewareManager courseware comment at:1) text = 'This is a comment about the courseware'.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'has 6/28/2013 18:05'!
testAsIncludeCoursewareNormal
	
	| aTag aListTag aListAuthor aListCourse |
	
	aTag := Tag new.
	aTag label: 'CoursewareTag'.
	aListTag := OrderedCollection new.
	aListTag add: aTag.
	
	aListAuthor := OrderedCollection new.
	aListAuthor add: 'Author 1'; add: 'Author 2'.
	
	aListCourse := OrderedCollection new.
	aListCourse add: ObjectFactoryTest createCourseToGetAllModerators.
	
	coursewareManager includeCourseware: 'First courseware' withDescription: 'Description of the courseware' withSummary: 'Summary of the courseware' withCoursewareType: #Slide withReference: 'http://reference.com' withOwner: 'User' withTag: aListTag withCourse: aListCourse withAuthor: aListAuthor withCataloguingData: 'Catalog information' withLicense: 'CC-CreativeCommons' withSize: 263.5 withFile: 'Slide1.pdf'.
	
	coursewareManager courseware: (Coursewares searchById:(Coursewares incrementId - 1)).
	
	self assert: coursewareManager courseware title = 'First courseware'.
	self assert: coursewareManager courseware description = 'Description of the courseware'.
	self assert: coursewareManager courseware summary = 'Summary of the courseware'.
	self assert: coursewareManager courseware coursewareType = #Slide.
	self assert: coursewareManager courseware reference = 'http://reference.com'.
	self assert: coursewareManager courseware owner = 'User'.
	self assert: coursewareManager courseware tag = aListTag.
	self assert: coursewareManager courseware course = aListCourse.
	self assert: coursewareManager courseware author = aListAuthor.
	self assert: coursewareManager courseware cataloguingData = 'Catalog information'.
	self assert: coursewareManager courseware license = 'CC-CreativeCommons'.
	self assert: coursewareManager courseware size = 263.5.
	self assert: coursewareManager courseware isEnabled = true.
	self assert: coursewareManager courseware downloadCounter = 0.
	self assert: coursewareManager courseware file = 'Slide1.pdf'.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'has 6/27/2013 19:12'!
testAsIncludeOrUpdateCoursewareScoreNormal

	| scoreTemp coursewareTemp user1 user2 |
	
	user1 := User new.
	user1 username: 'User'.
	user1 login: 'login'.
	user2 := User new.
	user2 username: 'User2'.
	user2 login: 'u2'.
	scoreTemp := Dictionary new.
	scoreTemp at: (user1 login) put: 2.5.
	coursewareTemp := ObjectFactoryTest createCoursewareNew1.
	coursewareTemp score: scoreTemp.
	coursewareManager includeCourseware: coursewareTemp.
	coursewareManager courseware: coursewareTemp.
	coursewareManager includeOrUpdateCoursewareScore: coursewareManager courseware ofUser: user2 withScore: 3.1.

	self assert: coursewareManager courseware score size = 2.
	self assert: (coursewareManager courseware score at: (user1 login)) = 2.5.
	self assert: (coursewareManager courseware score at: (user2 login)) = 3.1.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'has 6/27/2013 19:14'!
testAsIncludeOrUpdateCoursewareScoreNormalUpdatingScore

	| scoreTemp coursewareTemp user1 |
	
	user1 := User new.
	user1 username: 'User'.
	user1 login: 'login'.
	scoreTemp := Dictionary new.
	scoreTemp at: (user1 login) put: 2.5.
	coursewareTemp := ObjectFactoryTest createCoursewareNew1.
	coursewareTemp score: scoreTemp.
	coursewareManager includeCourseware: coursewareTemp.
	coursewareManager courseware: coursewareTemp.
	coursewareManager includeOrUpdateCoursewareScore: coursewareManager courseware ofUser: user1 withScore: 5.0.

	self assert: coursewareManager courseware score size = 1.
	self assert: (coursewareManager courseware score at: (user1 login)) = 5.0.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'has 6/24/2013 16:24'!
testAsIncrementDownloadCounterNormal

	| coursewareTemp |

	coursewareTemp := ObjectFactoryTest createCoursewareNew1.
	coursewareManager includeCourseware: coursewareTemp.
	coursewareManager courseware: (coursewareManager incrementDownloadCounter: coursewareTemp).

	self assert: coursewareManager courseware downloadCounter = 1.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'has 6/28/2013 15:53'!
testAsIsProfessorAtCourseNormal

	| coursewareTemp booleanValue course1 course2 user1 oc |

	coursewareTemp := Courseware new.
	
	course1 := ObjectFactoryTest createCourse1WithinGroup.
	course2 := ObjectFactoryTest createCourse2WithinGroup.
	user1 := User new.
	user1 username: 'gustavo'.
	user1 login: 'gu'.
	user1 includeOrUpdateGroup: (course1 group at:1) withRole: UserType moderator.
	user1 includeOrUpdateGroup: (course2 group at:1) withRole: UserType student.
	oc := OrderedCollection new.
	oc add: course1.
	oc add: course2.
	coursewareTemp course: oc.
	
	booleanValue := coursewareManager isModerator: user1 atCourseware: coursewareTemp.

	self assert: booleanValue = true.! !

!CoursewareManagerTest methodsFor: 'testing' stamp: 'has 6/27/2013 19:15'!
testAsUnblockCoursewareNormal

	| coursewareTemp user1 |

	user1 := User new.
	user1 username: 'User'.
	user1 login: 'login'.
	coursewareTemp := ObjectFactoryTest createCoursewareNew1.
	coursewareTemp isEnabled: false.
	coursewareTemp owner: user1.
	coursewareManager includeCourseware: coursewareTemp.
	coursewareManager courseware: (coursewareManager unblockCourseware: coursewareTemp user: user1).

	self assert: coursewareManager courseware isEnabled = true.! !

TestCase subclass: #CoursewareTest
	instanceVariableNames: 'courseware'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!CoursewareTest commentStamp: 'HAS 4/28/2013 17:53' prior: 0!
This class contains some tests about the class Courseware!

!CoursewareTest methodsFor: 'initialize-release' stamp: 'HAS 4/28/2013 18:00'!
setUp
	courseware := Courseware new.! !

!CoursewareTest methodsFor: 'testing' stamp: 'has 6/24/2013 07:00'!
testAsAddAuthors
	| authorCollection |
	authorCollection := OrderedCollection new.
	authorCollection add: 'John Master'.
	authorCollection add: 'A.M. Fliguer'.
	courseware author: authorCollection.
	self assert: (courseware author size) = 2.! !

!CoursewareTest methodsFor: 'testing' stamp: 'has 6/24/2013 09:40'!
testAsAddComment
	| commentCollection |
	commentCollection := OrderedCollection new.
	commentCollection add: ObjectFactoryTest createComment1.
	commentCollection add: ObjectFactoryTest createComment2.
	courseware comment: commentCollection.
	self assert: (courseware comment size) = 2.! !

!CoursewareTest methodsFor: 'testing' stamp: 'has 6/28/2013 14:23'!
testAsAddCourse
	
	| courseware1 oc |
	courseware1:= ObjectFactoryTest createCoursewareNew1.
	oc:= OrderedCollection new.
	oc add:ObjectFactoryTest createGroup1WithinCourse.
	courseware1 course: oc.

	self assert: ((courseware1 course) size = 1).! !

!CoursewareTest methodsFor: 'testing' stamp: 'has 6/24/2013 10:56'!
testAsAddTag
	courseware tag: ObjectFactoryTest createTagCollection1.
	self assert: (courseware tag size) = 1.! !

!CoursewareTest methodsFor: 'testing' stamp: 'HAS 4/28/2013 18:16'!
testAsCoursewareTypeCorrect
	courseware coursewareType: #Audio.
	self assert: courseware coursewareType = #Audio! !

!CoursewareTest methodsFor: 'testing' stamp: 'HAS 4/28/2013 18:23'!
testAsCoursewareTypeWrong
	self should: [courseware coursewareType: #None] raise: Error! !

!CoursewareTest methodsFor: 'testing' stamp: 'HAS 4/28/2013 18:31'!
testAsId
	courseware id: 123.
	self assert: courseware id = 123! !

!CoursewareTest methodsFor: 'testing' stamp: 'HAS 4/28/2013 18:39'!
testAsIdDifferentType
	self should:[courseware id: '123'] raise: Error! !

!CoursewareTest methodsFor: 'testing' stamp: 'HAS 4/28/2013 18:11'!
testAsTitle
	courseware title: 'Courseware Title'.
	self assert: courseware title = 'Courseware Title'! !

!CoursewareTest methodsFor: 'testing' stamp: 'has 6/24/2013 10:55'!
testAsUsersWithWritePermissions
	courseware usersWithWritePermission: ObjectFactoryTest createUserCollection1.
	self assert: (courseware usersWithWritePermission size) = 2.! !

TestCase subclass: #CoursewareTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!CoursewareTypeTest methodsFor: 'accessing' stamp: 'has 6/24/2013 10:00'!
testAudio
	self assert: (CoursewareType coursewareTypeList includes: CoursewareType audio).! !

!CoursewareTypeTest methodsFor: 'accessing' stamp: 'has 6/24/2013 10:00'!
testCode
	self assert: (CoursewareType coursewareTypeList includes: CoursewareType code).! !

!CoursewareTypeTest methodsFor: 'accessing' stamp: 'has 6/24/2013 10:01'!
testExercise
	self assert: (CoursewareType coursewareTypeList includes: CoursewareType exercise).! !

!CoursewareTypeTest methodsFor: 'instance creation' stamp: 'has 6/24/2013 09:59'!
testNew
	self should: [CoursewareType new] raise: Error.! !

!CoursewareTypeTest methodsFor: 'accessing' stamp: 'has 6/24/2013 10:01'!
testProgram
	self assert: (CoursewareType coursewareTypeList includes: CoursewareType program).! !

!CoursewareTypeTest methodsFor: 'accessing' stamp: 'has 6/24/2013 10:01'!
testSlide
	self assert: (CoursewareType coursewareTypeList includes: CoursewareType slide).! !

!CoursewareTypeTest methodsFor: 'accessing' stamp: 'has 6/24/2013 10:02'!
testText
	self assert: (CoursewareType coursewareTypeList includes: CoursewareType text).! !

!CoursewareTypeTest methodsFor: 'accessing' stamp: 'has 6/24/2013 10:02'!
testVideo
	self assert: (CoursewareType coursewareTypeList includes: CoursewareType video).! !

TestCase subclass: #OCMSNotificationManagerTest
	instanceVariableNames: 'notificationManager professor student normalNotification systemNotification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!OCMSNotificationManagerTest methodsFor: 'setUp' stamp: 'has 6/27/2013 19:17'!
setUp
	"Setups a empty notification manager, users, a normal Notification and a System notification"
	notificationManager := OCMSNotificationManager new.
	professor := User new isEnabled: true;
		username: 'Professor';
		email: 'professor@test.com';
		login: 'professor';
		password: 'professor'.
							
	student := User new username: 'Student';
		email: 'student@test.com';
		login: 'student';
		password: 'student'.
				
	normalNotification := OCMSNotification new title: 'Normal Notification';
		body: 'This is a normal notification.';
		sender: professor.
	normalNotification addReceiver: student.
	
	systemNotification := OCMSNotification new title: 'System Notification';
		body: 'This is a system notification';
		isSystemNotification: true.
	systemNotification addReceiver: student; addReceiver: professor.! !

!OCMSNotificationManagerTest methodsFor: 'accessing' stamp: 'has 6/24/2013 17:32'!
testHasUnreadNotificationOfUser
	systemNotification readWithUser: student.
	notificationManager includeNotification: systemNotification.
	self assert: (notificationManager hasUnreadNotificationOfUser: professor).! !

!OCMSNotificationManagerTest methodsFor: 'accessing' stamp: 'oda 5/13/2013 03:18'!
testIncludeNotification
	self shouldnt: [notificationManager includeNotification: normalNotification] raise: Error.
	self shouldnt: [notificationManager includeNotification: systemNotification] raise: Error.
	self should: [notificationManager includeNotification: 'notANotification'] raise: Error.! !

!OCMSNotificationManagerTest methodsFor: 'initialize-release' stamp: 'oda 5/13/2013 03:04'!
testInitialize
	self assert: notificationManager notification isEmpty.! !

!OCMSNotificationManagerTest methodsFor: 'accessing' stamp: 'oda 5/13/2013 03:29'!
testReceivedNotificationOfUser
	notificationManager includeNotification: systemNotification.
	self assert: ((notificationManager receivedNotificationOfUser: student) includes: systemNotification).
	self deny: ((notificationManager receivedNotificationOfUser: student) includes: normalNotification).
	self assert: ((notificationManager receivedNotificationOfUser: professor) includes: systemNotification).! !

!OCMSNotificationManagerTest methodsFor: 'accessing' stamp: 'oda 5/13/2013 03:23'!
testRemoveNotification
	notificationManager includeNotification: normalNotification.
	notificationManager includeNotification: systemNotification.
	self shouldnt: [notificationManager removeNotification: normalNotification] raise: Error.
	self should: [notificationManager removeNotification: normalNotification] raise: Error.
	self shouldnt: [notificationManager removeNotification: systemNotification] raise: Error.
	self should: [notificationManager removeNotification: 'notANotification'] raise: Error! !

!OCMSNotificationManagerTest methodsFor: 'accessing' stamp: 'oda 5/13/2013 03:27'!
testSentNotificationOfUser
	notificationManager includeNotification: normalNotification.
	self assert: ((notificationManager sentNotificationOfUser: professor) includes: normalNotification).
	self deny: ((notificationManager sentNotificationOfUser: student) includes: normalNotification).
	self deny: ((notificationManager sentNotificationOfUser: professor) includes: systemNotification).! !

TestCase subclass: #OCMSNotificationTest
	instanceVariableNames: 'normalNotification systemNotification student professor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!OCMSNotificationTest methodsFor: 'setUp' stamp: 'has 6/27/2013 19:18'!
setUp
	"Setups a normal Notification and a System notification"
	professor := User new isEnabled: true;
		username: 'Professor';
		email: 'professor@test.com';
		login: 'professor';
		password: 'professor'.
							
	student := User new username: 'Student';
		email: 'student@test.com';
		login: 'student';
		password: 'student'.
				
	normalNotification := OCMSNotification new title: 'Normal Notification';
		body: 'This is a normal notification.';
		sender: professor.
	normalNotification addReceiver: student.
	
	systemNotification := OCMSNotification new title: 'System Notification';
		body: 'This is a system notification';
		isSystemNotification: true.
	systemNotification addReceiver: student; addReceiver: professor.! !

!OCMSNotificationTest methodsFor: 'accessing' stamp: 'has 6/24/2013 13:01'!
testAsIsNormalNotification
	| notification |
	notification := ObjectFactoryTest createNormalNotification.
	self assert: (notification isSystemNotification = false).! !

!OCMSNotificationTest methodsFor: 'accessing' stamp: 'has 6/24/2013 12:58'!
testAsIsSystemNotification
	| notification |
	notification := ObjectFactoryTest createSystemNotification.
	self assert: (notification isSystemNotification = true).! !

!OCMSNotificationTest methodsFor: 'accessing' stamp: 'has 6/24/2013 13:05'!
testAsReceiverSize
	| notification |
	notification := ObjectFactoryTest createSystemNotification.
	self assert: (notification receiver size = 2).! !

!OCMSNotificationTest methodsFor: 'accessing' stamp: 'has 6/24/2013 13:07'!
testAsReceiverUserLogin
	| notification |
	notification := ObjectFactoryTest createSystemNotification.
	self assert: ((notification receiver at:1) login = 'user1').! !

!OCMSNotificationTest methodsFor: 'accessing' stamp: 'has 6/25/2013 10:47'!
testAsSenderUserLogin
	| notification |
	notification := ObjectFactoryTest createNormalNotification.
	self assert: ((notification sender) login = 'enabled2').! !

!OCMSNotificationTest methodsFor: 'comparing' stamp: 'oda 5/13/2013 03:59'!
testEquals
	| systemNotificationCopy |
	self assert: normalNotification = normalNotification.
	self deny: normalNotification = systemNotification.
	
	systemNotificationCopy := OCMSNotification new title: (systemNotification title);
		body: (systemNotification body);
		sender: (systemNotification sender);
		isSystemNotification: (systemNotification isSystemNotification);
		dateAndTime: (systemNotification dateAndTime).
	systemNotification receiver do: [:each | systemNotificationCopy addReceiver: each].
	
	self assert: systemNotification = systemNotificationCopy.! !

!OCMSNotificationTest methodsFor: 'accessing' stamp: 'oda 5/13/2013 04:22'!
testIsReadbyUser
	self deny: (normalNotification isReadByUser: student).
	normalNotification readWithUser: student.
	self assert: (normalNotification isReadByUser: student).! !

!OCMSNotificationTest methodsFor: 'accessing' stamp: 'oda 5/13/2013 04:21'!
testReadWithUser
	self shouldnt: [normalNotification readWithUser: student] raise: Error.
	self should: [normalNotification readWithUser: professor] raise: Error.! !

TestCase subclass: #TagManagerTest
	instanceVariableNames: 'tag relatedTag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!TagManagerTest commentStamp: '<historical>' prior: 0!
This class contains some tests about the class Tag!

!TagManagerTest methodsFor: 'initialize-release' stamp: 'has 6/24/2013 13:36'!
setUp

	tag := Tag new.! !

!TagManagerTest methodsFor: 'testing' stamp: 'has 6/28/2013 15:10'!
testAsIncludeTagNormal
	
	| tagTemp tg |
	tagTemp := TagManager new. 
	tg:= Tag new.
	tg label: 'Main tag'.
	(Tags tagExists: tg)
		ifTrue:[tagTemp removeTag: tg].
	tagTemp includeTag: tg label.
	tag label: 'Main tag'.
	self assert: ((Tags tagExists: tag) = true).! !

!TagManagerTest methodsFor: 'testing' stamp: 'has 6/28/2013 15:41'!
testAsUpdateTagNormal
	
	| tagTemp tg tgUpdate |
	tagTemp := TagManager new. 
	tg:= Tag new.
	tg label: 'Main tag'.
	(Tags tagExists: tg)
		ifTrue:[tagTemp removeTag: tg].
	tagTemp includeTag: tg label.
	tg := (tagTemp searchTag:'Main tag') at:1.
	tg label: 'MainTAG'.
	tagTemp updateTag: tg.
	tgUpdate := (tagTemp searchTag:'MainTAG') at:1.
	self assert: (Tags tagExists: tg).
	self assert: (tgUpdate label = 'MainTAG').! !

TestCase subclass: #TagTest
	instanceVariableNames: 'tag relatedTag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!TagTest commentStamp: 'HAS 4/28/2013 17:53' prior: 0!
This class contains some tests about the class Tag!

!TagTest methodsFor: 'initialize-release' stamp: 'HAS 4/29/2013 20:36'!
setUp

	tag := Tag new.! !

!TagTest methodsFor: 'testing' stamp: 'has 6/27/2013 09:39'!
testAsLabel
	
	tag label: 'Main tag'.
	self assert: tag label = 'Main tag'! !

!TagTest methodsFor: 'testing' stamp: 'has 6/27/2013 09:39'!
testAsName
	
	tag label: 'Main tag'.
	self assert: tag label = 'Main tag'! !

TestCase subclass: #UserManagerTest
	instanceVariableNames: 'userManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!UserManagerTest methodsFor: 'setUp' stamp: 'oda 5/1/2013 23:21'!
setUp
	userManager := UserManager new.! !

!UserManagerTest methodsFor: 'accessing' stamp: 'oda 6/30/2013 23:40'!
testAuthenticateUserWithLogin
	| anUser |
	anUser := User new login: 'authenticateUser'; 
					username:'Authenticated User'; 
					email: 'auth@test.com';
					password: 'password'; 
					isEnabled: true.
	((userManager userWithLogin: anUser login) isNil)
		ifTrue:[userManager includeUser: anUser.]
		ifFalse:[anUser:= userManager userWithLogin: anUser login.].
	
	self assert: ((userManager authenticateUserWithLogin: anUser login withPassword: anUser password) = anUser).
	self deny: ((userManager authenticateUserWithLogin: anUser login withPassword: 'wrongPassword') = anUser).
	self deny: ((userManager authenticateUserWithLogin: 'UnregisteredLogin' withPassword: anUser password) = anUser).! !

!UserManagerTest methodsFor: 'accessing' stamp: 'has 6/25/2013 05:43'!
testBlockUser
	| anUser |
	anUser := ObjectFactoryTest createUser1Enabled.
	((userManager userWithLogin: anUser login) isNil)
		ifTrue:[userManager includeUser: anUser.]
		ifFalse:[anUser:= userManager userWithLogin: anUser login.
				anUser isEnabled:true.].
	userManager blockUser: anUser.
	self deny: (userManager userWithLogin: anUser login) isEnabled.! !

!UserManagerTest methodsFor: 'accessing' stamp: 'has 6/25/2013 07:09'!
testIncludeUser
	((userManager userWithLogin: 'anuser') isNil)
			ifFalse:[userManager removeUserWithLogin:'anuser'].
	self shouldnt: [
		userManager includeUserWithLogin: 'anuser'
					withPassword: 'test'
					withEmail: 'test@test.com'
					withName: 'User'
					isAdmin: false
		] raise: Error.
	
	self should: [
		userManager includeUserWithLogin: 'anuser'
					withPassword: 'test'
					withEmail: 'test@test.com'
					withName: 'User'
					isAdmin: false
		] raise: Error.! !

!UserManagerTest methodsFor: 'initialize-release' stamp: 'oda 5/1/2013 23:51'!
testInitialize
	self assert: userManager user isEmpty.! !

!UserManagerTest methodsFor: 'accessing' stamp: 'has 6/25/2013 06:01'!
testRemoveUser
	| user1 user2  anotherUser2 |
	user1 := ObjectFactoryTest createUser1Enabled.
	user2 := ObjectFactoryTest createUser2Enabled.
	anotherUser2 := ObjectFactoryTest createUser1Disabled.
	
	((userManager userWithLogin: user1 login) isNil)
		ifTrue:[userManager includeUser: user1.]
		ifFalse:[user1:= userManager userWithLogin: user1 login.].
	
	((userManager userWithLogin: anotherUser2 login) isNil)
		ifTrue:[userManager includeUser: anotherUser2.]
		ifFalse:[anotherUser2:= userManager userWithLogin: anotherUser2 login.].
	
	
	self shouldnt: [userManager removeUser: user1] raise: Error.
	self should: [userManager removeUser: user2] raise: Error.
	self should: [userManager removeUser: user1] raise: Error.
		
	self shouldnt: [userManager removeUser: anotherUser2] raise: Error.
	
	((userManager userWithLogin: user2 login) isNil)
		ifTrue:[userManager includeUser: user2.]
		ifFalse:[user2:= userManager userWithLogin: user2 login.].
	
	self shouldnt: [userManager removeUserWithLogin: user2 login] raise: Error.
	
! !

!UserManagerTest methodsFor: 'accessing' stamp: 'has 6/25/2013 07:07'!
testUnblockUser
	| anUser |
	anUser := ObjectFactoryTest createUser1Enabled.
	((userManager userWithLogin: anUser login) isNil)
		ifTrue:[userManager includeUser: anUser.]
		ifFalse:[anUser:= userManager userWithLogin: anUser login.].
	userManager blockUser: anUser.
	userManager unblockUserWithLogin: anUser login.
	self assert: (userManager userWithLogin: anUser login) isEnabled.! !

!UserManagerTest methodsFor: 'accessing' stamp: 'oda 6/30/2013 23:39'!
testUpdateUser
	| anUser |
	anUser := ObjectFactoryTest createUser1Enabled.
	((userManager userWithLogin: anUser login) isNil)
		ifTrue:[userManager includeUser: anUser.]
		ifFalse:[anUser:= userManager userWithLogin: anUser login.].
	
	self should: [userManager updateUser: (User new login: 'dontExists')] raise: Error.
	self shouldnt: [userManager updateUserWithLogin: anUser login
								withPassword: 'anotherPassword'
								withEmail: 'user1@test.com'
								withName: 'anotherName'
								isAdmin: false
								isEnabled: true
		] raise: Error.

	anUser:= userManager userWithLogin: anUser login.
	self assert: anUser password = 'anotherPassword' hash.
	self assert: anUser email = 'user1@test.com'.
	self assert: anUser username = 'anotherName'.! !

!UserManagerTest methodsFor: 'accessing' stamp: 'has 6/25/2013 07:29'!
testUserWithLogin
	| anUser anotherUser |
	anUser := ObjectFactoryTest createUser2Enabled.
	((userManager userWithLogin: anUser login) isNil)
		ifTrue:[userManager includeUser: anUser.]
		ifFalse:[anUser:= userManager userWithLogin: anUser login.].
	
	self assert: ((userManager userWithLogin: 'doesntExist') isNil).
	
	self shouldnt: [anotherUser := userManager userWithLogin: anUser login] raise: Error.
	self assert: anotherUser == anUser.! !

TestCase subclass: #UserTest
	instanceVariableNames: 'admin professor student'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!UserTest methodsFor: 'setUp' stamp: 'has 6/27/2013 19:21'!
setUp
	"Setups an admin, a professor and a student"
	admin := User new isAdmin: true;
						isEnabled: true;
						username: 'Admin';
						email: 'admin@test.com';
						login: 'admin';
						password: 'admin'.
	
	professor := User new isEnabled: true;
						username: 'Professor';
						email: 'professor@test.com';
						login: 'professor';
						password: 'professor'.
							
	student := User new username: 'Student';
						email: 'student@test.com';
						login: 'student';
						password: 'student'.! !

!UserTest methodsFor: 'comparing' stamp: 'has 6/24/2013 13:54'!
testAsHashLogin
	| user |
	user:= ObjectFactoryTest createUser1Enabled.
	self assert:(('user1' hash) = user hash).! !

!UserTest methodsFor: 'accessing' stamp: 'has 6/24/2013 13:58'!
testAsIsAdmin
	| user |
	user:= ObjectFactoryTest createUserAdmin1.
	self assert:(user isAdmin = true).! !

!UserTest methodsFor: 'accessing' stamp: 'has 6/24/2013 13:58'!
testAsIsAdminFalse
	| user |
	user:= ObjectFactoryTest createUser2Enabled.
	self assert:(user isAdmin = false).! !

!UserTest methodsFor: 'accessing' stamp: 'has 6/24/2013 13:59'!
testAsIsAdminUpdateTrue
	| user |
	user:= ObjectFactoryTest createUser2Enabled.
	user isAdmin: true.
	self assert:(user isAdmin = true).! !

!UserTest methodsFor: 'accessing' stamp: 'has 6/24/2013 14:01'!
testAsIsEnabled
	| user |
	user:= ObjectFactoryTest createUserAdmin1.
	self assert:(user isEnabled = true).! !

!UserTest methodsFor: 'accessing' stamp: 'has 6/24/2013 14:02'!
testAsIsEnabledFalse
	| user |
	user:= ObjectFactoryTest createUser1Disabled.
	self assert:(user isEnabled = false).! !

!UserTest methodsFor: 'accessing' stamp: 'has 6/24/2013 14:03'!
testAsIsEnabledUpdateFalse
	| user |
	user:= ObjectFactoryTest createUser1Enabled.
	user isEnabled: false.
	self assert:(user isEnabled = false).! !

!UserTest methodsFor: 'comparing' stamp: 'oda 5/1/2013 19:48'!
testEquals
	"Asserts deep equality."
	self assert: admin = admin.
	self assert: admin = (User new login: (admin login)).
	self deny: admin = student.
	self deny: student = professor.! !

!UserTest methodsFor: 'accessing' stamp: 'oda 6/26/2013 21:40'!
testIncludeOrUpdateCourse
	"Tests consistency upon including a user role within a course"
	| aCourse aGroup |
	aGroup := ObjectFactoryTest createGroup1WithinCourse.
	aCourse := aGroup course.
	
	self should: [student includeOrUpdateGroup: aGroup withRole: 'anything'] raise: Error.
	self should: [student includeOrUpdateGroup: 'anything' withRole: UserType student] raise: Error.
	
	self shouldnt: [student includeOrUpdateGroup: aGroup withRole: UserType student] raise: Error.
	self assert: (student group includes: aGroup).
	self assert: (student course includes: aCourse).
	self assert: ((student roleAtGroup: aGroup) = UserType student).! !

!UserTest methodsFor: 'initialize-release' stamp: 'oda 5/3/2013 21:37'!
testInitialize
	"Asserts initialization after instance creation"
	self assert: admin isAdmin.
	self assert: admin isEnabled.
	self assert: admin course isEmpty.
	
	self deny: professor isAdmin.
	self assert: professor isEnabled.
	self assert: professor course isEmpty.

	self deny: student isAdmin.
	self deny: student isEnabled.
	self assert: student course isEmpty.
! !

!UserTest methodsFor: 'accessing' stamp: 'oda 6/26/2013 21:41'!
testRoleAtGroup
	"Tests accessing an user role within a group"
	| aCourse anotherCourse aGroup anotherGroup|
	aGroup := ObjectFactoryTest createGroup1WithinCourse.
	aCourse := aGroup course.
	anotherGroup := ObjectFactoryTest createGroup2WithinCourse.
	anotherCourse := anotherGroup course.
	
	student includeOrUpdateGroup: aGroup withRole: UserType student.
	self shouldnt: [student roleAtGroup: aGroup] raise: Error.
	self assert: (student roleAtGroup: aGroup) = UserType student.
	
	self should: [student roleAtGroup: 'aGroup'] raise: Error.
	self should: [student roleAtGroup: anotherGroup] raise: Error. 
	
	! !

TestCase subclass: #UserTypeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMSTest-Kernel'!

!UserTypeTest methodsFor: 'accessing' stamp: 'has 6/28/2013 14:02'!
testModerator
	self assert: (UserType userTypeList includes: UserType moderator).! !

!UserTypeTest methodsFor: 'instance creation' stamp: 'oda 5/1/2013 18:31'!
testNew
	self should: [UserType new] raise: Error.! !

!UserTypeTest methodsFor: 'accessing' stamp: 'has 6/24/2013 10:06'!
testStudent
	self assert: (UserType userTypeList includes: UserType student).! !
